##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################


"""
HTTPMounter
$Id: HTTPMounter.py,v 1.3 2002/05/16 17:05:34 andreasjung Exp $
"""

from Globals import Persistent,DTMLFile
from OFS.SimpleItem import SimpleItem
from Acquisition import Implicit
import string
import urllib


class HTTPMounter(Persistent, Implicit, SimpleItem):
    """ The HTTPMounter product acts like a dump LocalFS and mounts
        another HTTP into a running Zope instance.
    """

    meta_type = 'HTTPMounter'

    manage_options= (
        {'label': 'Settings',     
         'action': 'manage_workspace'
         },
    )


    def __init__(self, id, title, url): 
        self.id     = id
        self.title  = title
        self.url    = url
        self.default_document = 'index.html'


    def __bobo_traverse__(self, request, entry_name):
        """ fool Zope traversal - hehehe"""

        if entry_name in ('manage_main','manage_workspace', 'manage_preferences'): 
            return getattr(self, entry_name)

        return self 


    def __call__(self, REQUEST, RESPONSE):
        """ """
        own_path = string.join(self.getPhysicalPath(), '/')
        sub_path = REQUEST['PATH_TRANSLATED'].replace(own_path,'')
        if not sub_path: sub_path = self.default_document
        url = self.url 
        if url[-1] != '/': url = url + '/'
        url = url + sub_path
        data = urllib.urlopen(url).read()
        return data


    def manage_preferences(self, title, url, default_document, RESPONSE=None, URL1=None):
        """ save preferences """

        self.title = title
        self.url   = url
        self.default_document = default_document

        RESPONSE.redirect(URL1 + '/manage_main?manage_tabs_message=Settings%20saved')


    index_html = __call__

    manage_workspace  = DTMLFile("dtml/manageHTTPMounter",globals())


manage_addHTTPMounterForm = DTMLFile('dtml/addHTTPMounter', globals())

def manage_addHTTPMounter(self, id, title, url, REQUEST=None, RESPONSE=None, URL3=None):
    """Add a new HTTPMounter """

    mounter = HTTPMounter(id, title, url)
    self._setObject(id, mounter)

    if REQUEST is not None:
        return self.manage_main(self, REQUEST,update_menu=1)
    

